//bluetooth.h

//irq.h

#ifndef _BLUETOOTH_H_
#define _BLUETOOTH_H_


#define master 0x01
#define slave 0x02

#define on 0x01
#define off 0x00

#define no_parity 	0x00
#define odd_parity 	0x01
#define even_parity 0x02

#define b2400 	0x01
#define b4800 	0x02
#define b9600 	0x03
#define b19200 	0x04
#define b38400 	0x05
#define b57600 	0x06
#define b115200 0x07
#define b230400 0x08
#define b460800 0x09
#define b921600 0x0A
#define b1382400 0x0B
#define b1843200 0x0C
#define b2764800 0x0D
#define b3686400 0x0B

void BT_Reset();
void BT_Start();
void BT_CloseConnection();
void BT_OpenConnection();
void BT_EnterHCM();
void BT_SetSerialPortConfig(unsigned char baudrate, unsigned char flowcontrol,
unsigned char parity, unsigned char databits, unsigned char stopbits);
void BT_SetLocalBluetoothName(unsigned char *name);
void BT_RunReboot();

#endif //_BLUETOOTH_H_