//hw.c

#include "hw.h"
#include "spi.h"
#include "serial.h"


//#pragma bit csMemory @ PORTC.1
//#pragma bit csAcc @ PORTC.0

#define ENABLE 	0 
#define DISABLE 1 

//#pragma bit Led @ PORTC.2
//#pragma bit resetAcc @ PORTC.6
//#pragma bit Button @ PORTC.3
#define High 	1 
#define Low 	0


void writeMemoryArray(unsigned char dataByte, unsigned char AdressH, unsigned char AdressL){

	csMemory = ENABLE;
	sendDataSPI(0x06);	//Write Enable
	csMemory = DISABLE;
	csMemory = ENABLE;

	sendDataSPI(0x02);	//Write to Memory Array
	sendDataSPI(AdressH);	//Address High
	sendDataSPI(AdressL);	//Address Low
	sendDataSPI(dataByte);
	//..continue sendDataSPI(dataByte2); sendDataSPI(dataByte3);

	csMemory = DISABLE;	
}

unsigned char readMemoryArray(unsigned char AdressH, unsigned char AdressL)
{
	unsigned char dataByte;

	csMemory = ENABLE;
	sendDataSPI(0x04);	//Write Disable
	csMemory = DISABLE;

	csMemory = ENABLE;

	sendDataSPI(0x03);	//Read From Memory Array
	sendDataSPI(AdressH);	//Address High
	sendDataSPI(AdressL);	//Address Low
	sendDataSPI(0xFF);		//Dummy
	dataByte = readDataSPI();
	//..continue readdDataSPI(dataByte2); readDataSPI(dataByte3);
	
	csMemory = DISABLE;
	return dataByte;	
}

unsigned char readAcc(char axis, char frame)
{
	unsigned char dataByte;
	
	csAcc = ENABLE;

	switch (axis)
	{
		case ('X'):
			if(frame == 'm' || frame == 'M')
			{
				sendDataSPI(0x05<<2); //X MSB
				sendDataSPI(0x00); //Dummy
				dataByte = readDataSPI();
			}
			else
			{
				sendDataSPI(0x04<<2); //X LSB
				sendDataSPI(0x00); //Dummy
				dataByte = readDataSPI();
			}
		break;

		case ('Y'):
			if(frame == 'm' || frame == 'M')
			{
				sendDataSPI(0x07<<2); //Y MSB
				sendDataSPI(0x00); //Dummy
				dataByte = readDataSPI();
			}
			else
			{
				sendDataSPI(0x06<<2); //Y LSB
				sendDataSPI(0x00); //Dummy
				dataByte = readDataSPI();
			}
		break;

		case 'Z':
			if(frame == 'm' || frame == 'M')
			{
				sendDataSPI(0x9<<2); //Z MSB
				sendDataSPI(0x00); //Dummy
				dataByte = readDataSPI();
			}
			else
			{
				sendDataSPI(0x08<<2); //Z LSB
				sendDataSPI(0x00); //Dummy
				dataByte = readDataSPI();
			}
		break;
		default:
			dataByte = 0;
		break;
	}
	

	csAcc = DISABLE;
	return dataByte;
}

#define SPI_CSB 0x04
#define SPI_PORT PORTB
#define SCA3000_MODE_REG_READ (0x14*4)
#define SCA3000_MODE_REG_WRITE (0x14*4+1*2)
#define SCA3000_FREEFALL 0x10


int SCA3000_read_mode(void)
{
int mode = 0;

//SPI_PORT = SPI_PORT & (~SPI_CSB);
csAcc = ENABLE;

// SPDR = SCA3000_MODE_REG_READ;
sendDataSPI(0x14<<2);
//while (!(SPSR & (1 << SPIF))) ; // wait for ack
//SPDR = 0x00;
sendDataSPI(0x00); //Dummy
//while (!(SPSR & (1 << SPIF))) ; // wait for ack
//mode = SPDR;
mode = readDataSPI();
//SPI_PORT = SPI_PORT | SPI_CSB;
csAcc = DISABLE;

return mode;
}


void SCA3000_Enable_FreeFall_Detection(void)
{
int mode = 0;

mode = SCA3000_read_mode();
mode = mode | SCA3000_FREEFALL;

//SPI_PORT = SPI_PORT & (~SPI_CSB);
csAcc = ENABLE;

//SPDR = SCA3000_MODE_REG_WRITE;
sendDataSPI(SCA3000_MODE_REG_WRITE);

//while (!(SPSR & (1 << SPIF)));
//SPDR = mode;
sendDataSPI(mode);

// while (!(SPSR & (1 << SPIF)));
//SPI_PORT = SPI_PORT | SPI_CSB;
csAcc = DISABLE;
}


